package pl.webnet.JaTrac;

import java.awt.*;

class ImageBumpMap extends Texture
{
	int pixels[];
	int width, height;
	double magnitude;
	final double divRec = 1 / 255.;
	String filename;

	public ImageBumpMap()
	{
		super();
	}

	public ImageBumpMap(String filename)
	{
		this.filename = filename;

		initialize();
	}

	public Vec updateNormal(Vec n, Vec tan1Vec, Point uv)
	{
		double u = uv.x;
		double v = uv.y;
		Vec tan2Vec;
		double distortion;

		// we create vector perpendicular to tanget, so we have a surface
		tan2Vec = n.cross(tan1Vec);
		tan2Vec.unit();

		int s = (int)((width - 2) * u);
		int t = (int)((height - 2) * (1 - v));

		double du = (pixels[s + 1 + t * width] & 0xff) - (pixels[s + t * width] & 0xff);
		double dv = (pixels[s + (t + 1) * width] & 0xff) - (pixels[s + t * width] & 0xff);

		tan1Vec = tan1Vec.addVectorMultiple(n, -0.004 * dv);
		tan2Vec = tan2Vec.addVectorMultiple(n, 0.004 * du);

		Vec normal = tan1Vec.cross(tan2Vec);

		normal.unit();
		
		return normal;
	}

	public String[] getParamArray()
	{
		final String params[] = {
			"name", "name", "",
			"magnitude", "magnitude", "",
			"file", "filename", ""
		};

		return params;
	}
	
	public String[] getAttachArray() { return null; }

	public Object initialize()
	{
		DiskImageIO di = new DiskImageIO(filename);

		pixels = di.pixels;
		width = di.width;
		height = di.height;

		return this;
	}

	public int getProperties()
	{
		return TEXTURE_NORMALVEC;
	}

}
