package pl.webnet.JaTrac;

import java.awt.*;
import java.util.*;

abstract class Light extends TreeNode implements XmlSettable
{
	Point origin;
	Spectrum spectrum;
	double intensity = 1.0;

	public Point getOrigin() { return origin; }
	public Spectrum getSpectrum() { return spectrum; }
	public double getIntensity() { return intensity; }
	public abstract double shadow(RayTree rt, Point hitPoint, Vec lightVec, double len);

	public void setSpectrum(String sp)
	{
		spectrum = (Spectrum)ObjectIndex.find(sp, Spectrum.index);
		spectrum = spectrum.create(spectrum);
	}

	public String[] getParamArray()
	{
		String params[] = {
			"intensity", "intensity", "",
			"spectrum", "", "setSpectrum"
		};

		return params;
	}

	public String[] getAttachArray()
	{
		return null;
	}

	public Object initialize() { return this; }
	
}

