package pl.webnet.JaTrac;

class PlanarMapping extends Mapping
{
	Point x1, x2, x3, x4;
	Vec edge1, edge2;
	double edge1LenRec, edge2LenRec;
	boolean tileU = false;
	boolean flipU = false; 
	boolean tileV = false;
	boolean flipV = false; 

	public PlanarMapping(Point x1, Point x2, Point x3, Point x4)
	{
		this.x1 = new Point(x1);
		this.x2 = new Point(x2);
		this.x3 = new Point(x3);
		this.x4 = new Point(x4);

		edge1 = new Vec(x2.x - x1.x, x2.y - x1.y, x2.z - x1.z);
		edge2 = new Vec(x4.x - x1.x, x4.y - x1.y, x4.z - x1.z);
		edge1LenRec = 1 / edge1.unit();
		edge2LenRec = 1 / edge2.unit();
	}

	public Point getUV(Point hitPoint, Vec normal)
	{
		Vec originHit = new Vec(hitPoint, x1);
		double u = edge1.dot(originHit) * edge1LenRec;
		double v = edge2.dot(originHit) * edge2LenRec;

		//System.out.println("uv: " + u + ", " + v + " hp: " + hitPoint);

		if(tileU == true)
		{
			u = Math.abs(u);

			if(flipU == true && Math.floor(u) % 2 == 1)
				u = 1 - (u - Math.floor(u));
			else
				u = u - Math.floor(u);
		}

		if(tileV == true)
		{
			v = Math.abs(v);

			if(flipV == true && Math.floor(v) % 2 == 1)
				v = 1 - (v - Math.floor(v));
			else
				v = v - Math.floor(v);
		}

		if(u < 0 || u > 1 || v < 0 || v > 1)
			return null;
		else
			return new Point(u, 1 - v, 0.);
	}
}
