package pl.webnet.JaTrac;

import java.awt.*;

class PointLight extends Light implements XmlSettable
{
	Primitive lastPrimitive = null;

	public PointLight()
	{
	}

	public PointLight(Point origin, Spectrum spectrum)
	{
		this.origin = new Point(origin);
		this.spectrum = spectrum;
	}

	public String[] getParamArray()
	{
		String params[] = {
			"origin", "origin", ""
		};

		return ParamHelper.mergeParams(super.getParamArray(), params);
	}

	public String[] getAttachArray() { return null; }
	public Object initialize() { return this; }


	public double shadow(RayTree rt, Point hitPoint, Vec lightVec, double len)
	{
		Ray lightRay = new Ray(hitPoint, lightVec);

		// check if the object we hit with previous shadowfeeler isn't
		// still blocking the light. If so, we can save some time
		// by not checking other primitives along the ray
		if(lastPrimitive != null)
		{
			if(lastPrimitive.intersect(lightRay) > 0)
			{
				if(((Intersection)lightRay.intersections.first()).t < len - Ray.EPSILON)
				{
					return 0;
				}
			}
			else
				lastPrimitive = null;
		}


		if(rt.iTester.intersectShadowfeeler(lightRay) != 0)
		{
			if(((Intersection)lightRay.intersections.first()).t < len - Ray.EPSILON)
			{
				lastPrimitive = ((Intersection)lightRay.intersections.first()).primitive;
				return 0;
			}
		}
			
		return 1;
	}
}
