package pl.webnet.JaTrac;

import java.util.*;
import java.awt.*;

class Ray extends Vec
{
	static public final double EPSILON = 1e-9;
	static long count = 0;

	Point origin;

	// while we do not currently need to keep a list of all intersections,
	// we keep it anyway, because it will probably be useful in future
	// implementation of CSG. Storing intersections in a sorted lists
	// is obviously a performance hit, especially when tracing rays without
	// intersection testing optimization.
	TreeSet intersections;
	Ray reflectedRay = null;
	Ray[] shadow = null;
	Ray transmittedRay = null;
	Spectrum spectrum;
	int generation = 0;
	long serialId;

	public Ray(Point origin, Vec direction)
	{
		this.origin = new Point(origin);
		intersections = new TreeSet();
		copy(direction);
		unit();
		count++;
		serialId = count;
	}

	public Point rayPoint(double t)
	{
		return new Point(x * t + origin.x, y * t + origin.y, z * t + origin.z);
	}

}
