package pl.webnet.JaTrac;

/**
 * SphereFlake implements example procedural creation plugin.
 * @author: Miloslaw Smyk (thorgal@amiga.com.pl)
 * @version: $Id$
 */


class SphereFlake extends TreeNode implements XmlSettable
{
	int depth;
	Point origin;
	double size;
	Mapping mapping = null;
	Spectrum spectrum = null;
	Level level = new Level();

	public SphereFlake()
	{
	}

	public String[] getParamArray()
	{
		String params[] = {
			"depth", "depth", "",
			"origin", "origin", "",
			"mapping", "mapping", "",
			"spectrum", "spectrum", "",
			"size", "size", ""
		};

		return params;
	}

	public String[] getAttachArray()
	{
		String params[] = {
		};

		return params;
	}

	public Object initialize()
	{
		Sphere s;
		Point p = new Point(0., 0., 0.);

		level.setParent(parent);
		
		for(int i = 0; i < depth; i++)
		{
			p.x = origin.x + size * Math.random();
			p.y = origin.y + size * Math.random();
			p.z = origin.z + size * Math.random();

			s = new Sphere(p, size/Math.sqrt(depth));
			//s = new Sphere(p, size/depth);
			s.spectrum = spectrum;

			level.add(s);
		}

		if(mapping != null)
			level.add(mapping);

		return level;
	}

}	
