package pl.webnet.JaTrac;

/**
 * Classes implementing this interface can have their attributes
 * set directly in XML config file.
 * @author: Miloslaw Smyk (thorgal@amiga.com.pl)
 * @version: $Id: XmlSettable.java,v 1.1.1.1 2001/05/17 23:27:03 thorgal Exp $
 */

interface XmlSettable
{
/**
 * Get object's parameter array. The array maps XML element names to variable
 * names and, if setting one variable is not enough, lists names of functions
 * to call.
 * @return	object's parameter array.
 */
	public String[] getParamArray();

/**
 * Get object's attach array. The array specifies what functions to call to
 * attach children nodes to this object.
 * @return	object's attach array.
 */
	public String[] getAttachArray();

/**
 * Initialize object's internal state after setting all params from XML file.
 * Called after element's end tag is encountered in XML file.
 */
		public Object initialize();
}
